
;****************************************************
;
;******************* SNIFF ***************************
;
;
;****************************************************
  
;WRITTEN BY RON NEWTON
;03/28/04
;XTAL INTERNAL 4.0 MHZ

	RADIX		HEX	;HEX IS DEFAULT # FORMAT
	LIST      P=PIC12C671  ; LIST DIRECTIVE TO DEFINE PROCESSOR
	INCLUDE "P12c671.inc"  ; PROCESSOR SPECIFIC VARIABLE DEFINITIONS
	
    __CONFIG  _CP_OFF & _INTRC_OSC & _PWRTE_ON &_WDT_OFF & _MCLRE_OFF& _INTRC_OSC_NOCLKOUT   
 
TEMP           EQU     20H		 ;TEMPORARY REGISTER
DELAY		   EQU     21H		 ;DELAY REGISTER FOR TONE
M1			   EQU	   22H		 ;ONE SIDE OF WHEATSTONE BRIDGE
M2			   EQU	   23H		 ;OTHER SIDE OF WHEATSTONE BRIDGE
	

#DEFINE		   GREEN	GPIO,2
#DEFINE		   BUZZ		GPIO,4
#DEFINE		   RED 		GPIO,5

		ORG  00H
		ORG	 H'05' 		
		
AWAYWEGO
		MOVLW 	B'000011'		;PROGRAM INPUT-OUTPUTS
		TRIS  	GPIO		       	
		BSF		STATUS, RP0		;CHANGE PAGE
		MOVLW	B'100'			;PROGRAM A/D
		MOVWF	ADCON1
		BCF		STATUS, RP0		;CHANGE PAGE
   		MOVLW	D'5'			;SET DELAY
  		MOVWF	DELAY
  		
START
  		MOVLW	B'11000001'		;TURN ON A/D #0 
  		MOVWF	ADCON0    
  		BCF		PIR1,ADIF		;START A/D
  		BSF		ADCON0,GO
A1      BTFSS 	PIR1, ADIF		;WAIT FOR AD TO MEASURE
		GOTO  	A1    
  		MOVF	ADRES,0			;MOVE RESULTS INTO M2
  		MOVWF	M2

  		MOVLW	B'11001001'		;TURN ON A/D #1 
  		MOVWF	ADCON0      		
  		BCF		PIR1,ADIF		;START A/D
  		BSF		ADCON0,GO	
A2      BTFSS 	PIR1, ADIF		;WAIT FOR AD
	    GOTO  	A2  
  		MOVF	ADRES,0			;MOVE RESULTS INTO M1
  		MOVWF	M1 
 
	   MOVF		M2,0			;CHECK TO SEE IF M1 IS MORE THAN M2
	   SUBWF	M1,0
	   BTFSS	3,0
	   GOTO		S1				;IF LOWER JUMP TO S1
	   BSF		RED				;OTHERWISE TURN ON GREEN
	   BCF		GREEN
	   GOTO		START			;DO AGAIN UNTIL ADJUSTED.
S1	   BCF		RED				;TURN ON RED
	   BSF		GREEN
	   MOVF		M1,0			;SUBTRACT M1 FROM M2
	   SUBWF	M2,1			;RESULTS WILL BE IN M2
	   MOVLW	D'128'			;PUT 128 INTO M1
	   MOVWF	M1
	   MOVF		M2,0			;SUBTRACT M2 FROM 128
	   SUBWF	M1,1	   
	   MOVF		M1,0			;RESULTS ARE IN M1
	   MOVWF	TEMP			;MOVE IN TO TEMP REGISTER
S2	   BSF		BUZZ			;TURN ON BUZZER
	   DECFSZ	DELAY,1			;DELAY FOR TONE
	   GOTO		S2	 
	   MOVLW	D'5'			;RESET DELAY
 	   MOVWF	DELAY  		   	
	   DECFSZ	TEMP,1			;DECREASE TEMP FOR TONE
	   GOTO		S2
   	   MOVF		M1,0			;RELOAD TEMP FOR NEXT RUN
	   MOVWF	TEMP
S3	   BCF		BUZZ			;TURN OFF BUZZER
	   DECFSZ	DELAY,1			;DELAY FOR TONE
	   GOTO		S3	 
	   MOVLW	D'5'			;RESET DELAY
  	   MOVWF	DELAY  		   
	   DECFSZ	TEMP,1			;DEREASE TEMP FOR TONE
	   GOTO		S3
   	   MOVF		M1,0			;RESET TEMP FOR NEXT RUN
	   MOVWF	TEMP

	   GOTO		START 			;DO ALL OVER AGAIN
	    

		END
